//************************************************************
//		kjs.c  ,  ً}nk񃋁[`
//			Copyright by S.Asakura
//************************************************************
#include 	<m8c.h>			// part specific constants and macros
#include 	"PSoCAPI.h" 	// PSoC API definitions for all User Modules

//*******************************
//		O֐
//*******************************
#include	"printf.h"		// printf to
#include	"message.h"		// bZ[W\
#include	"detect.h"		// Mm[`
#include	"etc.h"			// X̃[eBeBE[`
#include	"radio-alarm.h"	// WIA[

//*******************************
// 萔 `Cvg^Cv錾CO[oϐ
//*******************************
#define 	FIRST_FLG		// ŏɕϐ̒`C2ڈȍ~͊Oϐ錾邽߂̃tO
#include	"kjs.h" 		// ً}nk񃋁[`


//*******************************
//	O[oϐ
//*******************************


//=========================================================================


//********************
// ً}nktO \(SIO)
//********************
void disp_kDetFlg(void) {
	extern	unsigned char	kDetFlg;	// ً}nktO, 0=o, 1=1񌟏o, 2=2񌟏o, ...
	extern	unsigned char	preKDetFlg;	// OkDetFlg̒l

	if ( kDetFlg > preKDetFlg ) {
		set_prtdev_sio(); 				// \uSIO(UART)ɂ
		printComma();					// J}(" , ")
		printf("KJS-%d", kDetFlg);
		preKDetFlg = kDetFlg;			// OkDetFlg̒l
	} // end if kDetFlg
}

//*******************************
//	ً}nk񌟏o 
//*******************************
void init_KJS(void) {
	extern	unsigned char	kEnable;		// xo̓Cl[u , 0:OFF, 1:ON, 2:ʏ\tg, 3:ONێ
	extern	unsigned char	audioEnable;	// o̓Cl[u , 0:OFF, 1:ON, 2:ʏ\tg
	extern	unsigned short	kOFF_time;		// xOFF^C(b)
	extern	unsigned char	kPoutDatBuf;	// xo̓f[^obt@

	// *****  x   *****
	kPoutDatBuf = (K_RST_SW_BIT | AUD_SW_BIT);
	SW_PORT = kPoutDatBuf;			// ̓XCb`pvAbvo
	kOFF_time = KOFF_DEFAULT;		// xOFF^C(b)
	kEnable = 2;					// xo̓Cl[u , 2:ʏ\tg
	clr_kFlg();						// xtO NA
	audioEnable = 2;				// o̓Cl[u , 2:ʏ\tg
	audioOut_OnOff(0);				// WIo, 1=ON, 0=OFF
}

//********************
// HELP KR}h
//********************
void help_KJS(void) {
	UART_1_CPutString(" KAx ; x=0:Alarm-");
	msg_ForceOFF();		// \_Force-OFF
	UART_1_CPutString(", 1:");
	msg_ForceON();		// \_Force-ON
	UART_1_CPutString(", 2:Controlled, 3:Hold-Alarm");
	UART_1_PutCRLF();					// s(CR,LF)

	UART_1_CPutString(" KRx ; x=0:Audio-");
	msg_ForceOFF();		// \_Force-OFF
	UART_1_CPutString(", 1:");
	msg_ForceON();		// \_Force-ON
	UART_1_CPutString(", 2:Controlled");
	UART_1_PutCRLF();					// s(CR,LF)

	UART_1_CPutString(" KTx ; x=1~9:Alarm-Time(minutes), A~E:(min*10)");
	UART_1_PutCRLF();					// s(CR,LF)
}

//*******************************
// KJSԕ\
//*******************************
void disp_KJS_stat(void) {
	extern	unsigned short	kOFF_time;		// xOFF^Cݒl(b)
	extern	unsigned char	kEnable;		// xo̓Cl[u , 0:OFF, 1:ON, 2:ʏ\tg, 3:ONێ
	extern	unsigned char	audioEnable;	// o̓Cl[u , 0:OFF, 1:ON, 2:ʏ\tg

	printf("kEnable = %d : ", kEnable);
	switch (kEnable) {
		case 0: 
			msg_ForceOFF();		// \_Force-OFF
			break;
		case 1: 
			msg_ForceON();		// \_Force-ON
			break;
		case 2: 
			msg_Normal();		// \_Normal
			break;
		case 3: 
			UART_1_CPutString("Hold-Alarm");
			break;
	} // end switch
	UART_1_PutCRLF();			// s(CR,LF)

	printf("kOFF_time = %d(sec)\r\n", kOFF_time);

	printf("AudioEnable = %d : ", audioEnable);
	switch (audioEnable) {
		case 0: 
			msg_ForceOFF();		// \_Force-OFF
			break;
		case 1: 
			msg_ForceON();		// \_Force-ON
			break;
		case 2: 
			msg_Normal();		// \_Normal
			break;
	} // end switch
	UART_1_PutCRLF();			// s(CR,LF)
}

//*******************************
// ً}ً}nkR}h('K') 
//*******************************
void cmdBR_KJS(unsigned char *str) {
	extern	unsigned short	kOFF_time;		// xOFF^Cݒl(b)
	extern	unsigned char	kEnable;		// xo̓Cl[u , 0:OFF, 1:ON, 2:ʏ\tg, 3:ONێ
	extern	unsigned char	audioEnable;	// o̓Cl[u , 0:OFF, 1:ON, 2:ʏ\tg
	unsigned char *strPtr;
	unsigned char num;

	set_prtdev_sio(); 				// \uSIO(UART)ɂ
	strPtr = str;
	strPtr++;
	switch (*strPtr) {
		case 'T' : 		// A[OFF܂łTime
		case 't' : 
			strPtr++;
			if ( *strPtr == '0' ) {										// 0
				kOFF_time = 30;											// xOFF^C(b)
			} else if ( (num = hexChar2num(*strPtr, 9)) <= 9 ) {		// 1`9
				kOFF_time = (num * 60);									// xOFF^C(b)
			} else if ( (num = hexChar2num(*strPtr, 0x0F)) <= 0x0F ) {	// 10`15
				kOFF_time = ((num - 9) * 600);							// xOFF^C(b)
			} else {
				kOFF_time = KOFF_DEFAULT;
			} // end if
			disp_KJS_stat();			// KJSԕ\
			break;
		case 'A' : 		// A[o̓Cl[u
		case 'a' : 
			strPtr++;
			if ( (num = hexChar2num(*strPtr, 3)) <= 3 ) {
				kEnable = num;	// xo̓Cl[u , 0:OFF, 1:ON, 2:ʏ\tg, 3:ONێ
			} else {
				kEnable = 2;	// xo̓Cl[u , 2:ʏ\tg
			} // end if
			disp_KJS_stat();			// KJSԕ\
			break;
		case 'R' : 		// Radioo̓Cl[u
		case 'r' : 
			strPtr++;
			if ( (num = hexChar2num(*strPtr, 2)) <= 2 ) {
				audioEnable = num;	// o̓Cl[u , 0:OFF, 1:ON, 2:ʏ\tg
			} else {
				audioEnable = 2;	// o̓Cl[u , 2:ʏ\tg
			} // end if
			disp_KJS_stat();			// KJSԕ\
			break;
		case 'H' : 		// Help
		case 'h' : 
			help_KJS();				// HELP KJSR}h
			break;
		default : 
			msg_InvalCmd();			// \_R}h
			help_KJS();				// HELP KJSR}h
			break;
	} // end switch cmd[1]
}

//*********************************************************************
//		xC o͐
//*********************************************************************

//********************
// xtO NA
//********************
void clr_kFlg(void) {
	extern	unsigned char	kDetFlg;		// ً}nk mtO, 0=o, 1=1񌟏o, 2=2񌟏o, ...
	extern	unsigned char	preKDetFlg;		// OkDetFlg̒l
	extern	unsigned char	kAlarmFlg;		// xtO , xo͏ , 1=oON , 0=OFF
	extern	unsigned short	kOFF_count;		// xOFF^C}̃JEgl(b)
	extern	unsigned char	detStatVisible;		// mXe[^X\tO, 0=\, 1=v_\, 2=S\

	kDetFlg = 0;					// ً}nk_otO1, 0=o, 1=o
	preKDetFlg = 0;					// OkDetFlg̒l
	kAlarmFlg = 0;					// xtO NA
	kAlarm_OnOff(0);				// xOFF
	kOFF_count = 0;					// xOFF^C}̃JEgl NA
}

//*******************************
// x_ON/OFF, 1=ON, 0=OFF
//*******************************
void kAlarm_OnOff(unsigned char onOff) {
	extern	unsigned char	kPoutDatBuf;	// xo̓f[^obt@

	if (onOff == 1) {
		kPoutDatBuf |= K_BIT;		// High, ON
	} else {
		kPoutDatBuf &= ~(K_BIT);	// Low, OFF
	} // end if
	K_PORT = kPoutDatBuf;
}

//*******************************
// xo |[O, 1b, kEnablekDetFlgŐ
//*******************************
void kAlarm_pol(void) {
	extern	unsigned char	kEnable;	// xo̓Cl[u , 0:OFF, 1:ON, 2:ʏ\tg, 3:ONێ
	extern	unsigned char	kDetFlg;	// ً}nk_otO1, 0=o, 1=o
	extern	unsigned char	preKDetFlg;	// OkDetFlg̒l
	extern	unsigned char	kAlarmFlg;	// xtO , xo͏ , 1=oON , 0=OFF
	extern	unsigned short	kOFF_time;		// xOFF^Cݒl(b)
	extern	unsigned short	kOFF_count;		// xOFF^C}̃JEgl(b)
	extern	unsigned char	detStatVisible;		// mXe[^X\tO, 0=\, 1=v_\, 2=S\

	if ( (kDetFlg != 0) && (SW_PORT & K_RST_SW_BIT) == 0 ) {		// x񃊃ZbgXCb`
		UART_1_CPutString(" , K_RST-SW");					// \̓s UART_1_CPutString g
		clr_kFlg();					// xtO NA
	} else if (kEnable == 0) {		// 0:OFF
		kAlarm_OnOff(0);						// xOFF
	} else if (kEnable == 1) {		// 1:ON
		kAlarm_OnOff(1);						// xON
	} else if (kEnable == 3) {		// 3:ONێ
		if ( ((kAlarmFlg == 0) && (kDetFlg > 0)) || (kDetFlg > preKDetFlg) ) {
			kAlarmFlg = 1;					// xtO Zbg
			kAlarm_OnOff(1);					// xON
		} // end if kAlarmFlg
	} else { // kEnable == 2		// 2:ʏ\tg
		if ( ((kAlarmFlg == 0) && (kDetFlg > 0)) || (kDetFlg > preKDetFlg) ) {
			kAlarmFlg = 1;					// xtO Zbg
			kAlarm_OnOff(1);					// xON
			kOFF_count = 0;					// xOFF^C}̃JEgl NA
		} else if ( kDetFlg == 0 ) {
			kAlarm_OnOff(0);					// xOFF
		} else if ( kDetFlg > 0 ) {
			kOFF_count++;						// xOFF^C}̃JEgl CNg
			if (kOFF_count >= kOFF_time) {		// xOFF^C}^CAbv
				clr_kFlg();						// xtO NA
				UART_1_CPutString(" , K_TimeOut");
			} // end if kOFF_count
		} // end if kAlarmFlg , kDetFlg
	} // end if kEnable
}

//*******************************
// WIo, 1=ON, 0=OFF
//*******************************
void audioOut_OnOff(unsigned char onOff) {
	extern		unsigned char	audioStat;		// o͏ , 0=Low_OFF, 1=High_ON

	if (onOff == 1) {
		ACB00CR1 |= 0x80;	// Analog Bus ڑCyӁzW[̔zuˑ
		ABF_CR0  |= 0x08;	// Analog Buf 0 ڑ
		audioStat = 1;		// o͏   , 0=Low_OFF, 1=High_ON
	} else {
		ACB00CR1 &= 0x7F;	// Analog Bus ؒfCꂾƐ؂ꂪ̂
		ABF_CR0  &= 0xF7;	// Analog Buf 0 ؒfCOFF
		audioStat = 0;		// o͏   , 0=Low_OFF, 1=High_ON
	} // end if
}

//*******************************
// WIo̓|[O, audioEnable, kAlarmFlg, radioAlmStatŐ
//*******************************
void audioOut_pol(void) {
	extern	unsigned char	audioEnable;	// o̓Cl[u , 0:OFF, 1:ON, 2:ʏ\tg
	extern	unsigned char	kAlarmFlg;		// xtO , xo͏ , 1=oON , 0=OFF
	extern	unsigned char	radioAlmStat;	// WIA[ , 0=Low_OFF, 1=High_ON

	if ((audioEnable == 1) || ((SW_PORT & AUD_SW_BIT) == 0) ) {	// 1:ON
		audioOut_OnOff(1);
	} else if (audioEnable == 0) {	// 0:OFF
		audioOut_OnOff(0);				// OFFŁAtO͕ςȂ
	} else {						// 2:ʏ\tg
		if ( (kAlarmFlg == 1) || (radioAlmStat == 1) ) {
			audioOut_OnOff(1);		// WIo, 1=ON
		} else if ( (kAlarmFlg == 0) && (radioAlmStat == 0) ) {
			audioOut_OnOff(0);		// WIo, 0=OFF
		} // end if
	} // end if audioEnable
}

