//************************************************************
//		bpf.c  ,  ohpXEtB^
//			Copyright by S.Asakura
//************************************************************
#include 	<m8c.h>			// part specific constants and macros
#include 	"PSoCAPI.h" 	// PSoC API definitions for all User Modules

//*******************************
//		O֐
//*******************************
#include	"printf.h"		// printf to
#include	"message.h"		// bZ[W\
#include	"etc.h"			// X̃[eBeBE[`

//*******************************
// 萔 `Cvg^Cv錾CO[oϐ
//*******************************
#define 	FIRST_FLG		// ŏɕϐ̒`C2ڈȍ~͊Oϐ錾邽߂̃tO
#include	"bpf.h"			// ohpXEtB^

//*******************************
//	O[oϐ
//*******************************

// *****  ohpXEtB^萔  *****
// BPF萔 {Q, C1, C2, C3, C4, CA, CB}
// const unsigned char bpfC[4][7]  = 		// bpfC[BPF][萔]
// { {  57,  1, 31,  9,  1, BPF2_0_FEEDBACK_32, BPF2_0_FEEDBACK_32 },  	// BPF0, Q=57
//   {  10,  1, 18,  7,  5, BPF2_0_FEEDBACK_32, BPF2_0_FEEDBACK_32 },  	// BPF1, Q=10
//   {   4,  1,  4,  4,  8, BPF2_0_FEEDBACK_32, BPF2_0_FEEDBACK_32 },  	// BPF2, Q= 4
//   {  16,  1, 24, 10,  3, BPF2_0_FEEDBACK_32, BPF2_0_FEEDBACK_32 } };	// BPF3, Q=16

// BPFSg(Hz)
//     0,   1,   2,   3,   4,   5,   6,   7,   8,   9,  10,  11,  12,  13,  14,  15  // gԍ
unsigned short bpf_f0[16] = 		// bpf_f0[gԍ]
  {  392, 415, 523, 554, 659, 698, 932, 988,1245,1319, 440, 880, 640,1024, 466, 604 };

// PWM_BPx, Periodݒl
//     0,   1,   2,   3,   4,   5,   6,   7,   8,   9,  10,  11,  12,  13,  14,  15  // gԍ
const unsigned short pwmP[4][16] = 		// pwmP[BPF][gԍ]
{ { 1407,1328,1054, 995, 836, 789, 591, 558, 443, 418,1254, 626, 862, 538,1184, 913 },   // 0, Q=57
  {  933, 881, 699, 660, 554, 523, 392, 370, 293, 277, 831, 415, 571, 357, 785, 605 },   // 1, Q=10
  {  327, 309, 245, 231, 194, 183, 137, 129, 102,  97, 291, 145, 200, 125, 275, 212 },   // 2, Q= 4
  { 1306,1232, 978, 923, 776, 732, 548, 518, 411, 389,1163, 581, 799, 499,1098, 847 } }; // 3, Q=16

// PGA_xQCݒ
// const unsigned char  pgaG[4] = { PGA_0_G5_33, PGA_0_G8_00, PGA_0_G8_00, PGA_0_G8_00 };	// pgaG[BPF]

//=========================================================================

//********************
// BPF_x CtC^_p؊
//********************
// void chgBPFQ1(unsigned char bpfNum,			// bpfNuḿABPF_x x
//               unsigned char bpfQ) {			// bpfQ , 0:Q=57 , 1:Q=10 , 2:Q=4, 3:Q=16
// 	switch (bpfNum) {
// 		case 0: 		// BPF_0
// 			BPF2_0_SetC1( bpfC[ bpfQ ][1] );
// 			BPF2_0_SetC2( bpfC[ bpfQ ][2] );
// 			BPF2_0_SetC3( bpfC[ bpfQ ][3] );
// 			BPF2_0_SetC4( bpfC[ bpfQ ][4] );
// 			BPF2_0_SetCA( bpfC[ bpfQ ][5] );
// 			BPF2_0_SetCB( bpfC[ bpfQ ][6] );
// 			break;
// 		case 1:  		// BPF_1
// 			BPF2_1_SetC1( bpfC[ bpfQ ][1] );
// 			BPF2_1_SetC2( bpfC[ bpfQ ][2] );
// 			BPF2_1_SetC3( bpfC[ bpfQ ][3] );
// 			BPF2_1_SetC4( bpfC[ bpfQ ][4] );
// 			BPF2_1_SetCA( bpfC[ bpfQ ][5] );
// 			BPF2_1_SetCB( bpfC[ bpfQ ][6] );
// 			break;
// 		case 2:  		// BPF_2
// 			BPF2_2_SetC1( bpfC[ bpfQ ][1] );
// 			BPF2_2_SetC2( bpfC[ bpfQ ][2] );
// 			BPF2_2_SetC3( bpfC[ bpfQ ][3] );
// 			BPF2_2_SetC4( bpfC[ bpfQ ][4] );
// 			BPF2_2_SetCA( bpfC[ bpfQ ][5] );
// 			BPF2_2_SetCB( bpfC[ bpfQ ][6] );
// 			break;
// 		case 3:  		// BPF_3
// 			BPF2_3_SetC1( bpfC[ bpfQ ][1] );
// 			BPF2_3_SetC2( bpfC[ bpfQ ][2] );
// 			BPF2_3_SetC3( bpfC[ bpfQ ][3] );
// 			BPF2_3_SetC4( bpfC[ bpfQ ][4] );
// 			BPF2_3_SetCA( bpfC[ bpfQ ][5] );
// 			BPF2_3_SetCB( bpfC[ bpfQ ][6] );
// 			break;
// 		default: 
// 			break;
// 	} // end switch
// }

//********************
// ubNƂ2̃tC^_؊
//********************
void chgBPFpair(unsigned char pairNum,  // pairNum, 0:BPF_0BPF_1 , 1:BPF_2BPF_3
                unsigned char bpfQ ,    // bpfQ   , 0:Q=57 , 1:Q=10 , 2:Q=4, 3:Q=16
                unsigned char f0num) {  // gԍ , 0`15
	if (pairNum == 0) {
// 		chgBPFQ1( 0 , bpfQ);		// BPF_0 CtC^_p؊	,	Q=16ɌŒ , PsoC Dsignerݒlgp
// 		chgBPFQ1( 1 , bpfQ);		// BPF_1 CtC^_p؊
		PWM16_BP01_Stop();
		PWM16_BP01_WritePeriod( pwmP[ bpfQ ][f0num] );				// gݒ
		PWM16_BP01_WritePulseWidth( (pwmP[ bpfQ ][f0num] >> 1) );	// pX, Duty50%
		PWM16_BP01_Start();
// 		PGA_0_SetGain( pgaG[ bpfQ ] );   	// PGA_0   QCݒ	,		G=8ɌŒ , PsoC Dsignerݒlgp
	} else if (pairNum == 1) {
// 		chgBPFQ1( 2 , bpfQ);		// BPF_2 CtC^_p؊	,	Q=16ɌŒ , PsoC Dsignerݒlgp
// 		chgBPFQ1( 3 , bpfQ);		// BPF_3 CtC^_p؊
		PWM16_BP23_Stop();
		PWM16_BP23_WritePeriod( pwmP[ bpfQ ][f0num] );				// gݒ
		PWM16_BP23_WritePulseWidth( (pwmP[ bpfQ ][f0num] >> 1) );	// pX, Duty50%
		PWM16_BP23_Start();
// 		PGA_2_SetGain( pgaG[ bpfQ ] );   	// PGA_2   QCݒ	,		G=8ɌŒ , PsoC Dsignerݒlgp
	} // end if
}

//*******************************
// ohpXEtB^ 
//*******************************
void init_BPF(void) {
	extern	unsigned short *ptr_bpf_f0;		// bpf_f0[16] ւ̃|C^

	PGA_2_Start(PGA_2_LOWPOWER);	// QCAv
	ACB02CR2 |= 0x14;		// ABusAGNDdóDyӁzW[̔zuˑD
	PGA_0_Start(PGA_0_LOWPOWER);
	BPF2_0_Start(BPF2_0_LOWPOWER);		// BPF
	BPF2_1_Start(BPF2_1_LOWPOWER);
	BPF2_2_Start(BPF2_2_LOWPOWER);
	BPF2_3_Start(BPF2_3_LOWPOWER);
	PWM16_BP01_Start();					// BPF2_0,1pNbN
	PWM16_BP23_Start();					// BPF2_2,3pNbN
	CMPPRG_1_Start(CMPPRG_1_LOWPOWER);	// Rp[^1 X^[g
	CMPPRG_3_Start(CMPPRG_3_LOWPOWER);	// Rp[^3 X^[g
	ptr_bpf_f0 = &bpf_f0[0];			// bpf_f0[16] ւ̃|C^
}

//********************
// HELP BPFR}h
//********************
// void help_BPF(void) {
// 	UART_1_CPutString(" BFpqf ; Change BPF, p:0-1, q:0-2, f:0-F");
// 	UART_1_PutCRLF();					// s(CR,LF)
// }

//*******************************
// ohpXEtB^R}h('B') 
//*******************************
// void cmdBR_BPF(unsigned char *str) {
// 	unsigned char *strPtr;
// 	unsigned char pairNum;		// pairNum, 0:BPF_0BPF_1 , 1:BPF_2BPF_3
// 	unsigned char bpfQ;			// bpfQ   , 0:Q=57 , 1:Q=10 , 2:Q=4, 3:Q=16
// 	unsigned char f0num;		// gԍ , 0`15
// 
// 	set_prtdev_sio(); 				// \uSIO(UART)ɂ
// 	strPtr = str;
// 	strPtr++;
// 	switch (*strPtr) {
// 		case 'F' : 		// BPFgeXg , gṕA荞݋̂߂ɁAKVXeZbg邱
// 		case 'f' : 		// 1FyA 0 or 1 , 2F 0`2 , 3Fg 0`F
// 			strPtr++;
// 			if ( (pairNum = hexChar2num(*strPtr, 1)) <= 1 ) {	// 1FyA 0 or 1
// 				strPtr++;
// 				if ( (bpfQ = hexChar2num(*strPtr, 3)) <= 3 ) {	// 2F 0`3
// 					strPtr++;
// 					if ( (f0num = hexChar2num(*strPtr, 15)) <= 15 ) {	// 3Fg 0`F
// 						INT_MSK0 &= 0xEB;				// Analog 1,3 荞݋֎~
// 						chgBPFpair(pairNum, bpfQ, f0num);	// ubNƂ2̃tC^_؊
// 						printf("Pair %d", pairNum);
// 						printf(", Q=%d", bpfC[bpfQ][0]);
// 						printf(", f0=%d(Hz)\r\n", bpf_f0[f0num]);
// 						printf("INT Disable.\r\n");
// 					} else {
// 						msg_InvalCmd();			// \_R}h
// 						help_BPF();				// HELP BPFR}h
// 					} // end if 3
// 				} else {
// 					msg_InvalCmd();			// \_R}h
// 					help_BPF();				// HELP BPFR}h
// 				} // end if 2
// 			} else {
// 				msg_InvalCmd();			// \_R}h
// 				help_BPF();				// HELP BPFR}h
// 			} // end if 1
// 			break;
// 		case 'H' : 		// Help
// 		case 'h' : 
// 			help_BPF();				// HELP BPFR}h
// 			break;
// 		default : 
// 			msg_InvalCmd();			// \_R}h
// 			help_BPF();				// HELP BPFR}h
// 			break;
// 	} // end switch cmd[1]
// }


