//************************************************************
//		detect.c  ,  Mm[`
//			Copyright by S.Asakura
//************************************************************
#include 	<m8c.h>			// part specific constants and macros
#include 	"PSoCAPI.h" 	// PSoC API definitions for all User Modules

//*******************************
//		O֐
//*******************************
#include	"printf.h"		// printf to
#include	"message.h"		// bZ[W\
#include	"bpf.h"			// ohpXEtB^
#include	"rtc-inner.h"	// RTCA^C NbN
#include	"jihou.h"		// 񃋁[`
#include	"kjs.h" 		// ً}nk񃋁[`
#include	"etc.h"			// X̃[eBeBE[`

//*******************************
// 萔 `Cvg^Cv錾CO[oϐ
//*******************************
#define 	FIRST_FLG		// ŏɕϐ̒`C2ڈȍ~͊Oϐ錾邽߂̃tO
#include	"detect.h"		// Mm[`

//*******************************
//	O[oϐ
//*******************************

unsigned char  pairUse;  	// gpBPF , 0:yA0(BPF_0BPF_1) , 1:yA1(BPF_2BPF_3) , 2:
//            [BPFyA][Xe[^X]
unsigned char  t50ms[N_STAT] ;				// mԂ̏I(~0.05sec)
unsigned char  f0num[2][N_STAT] ;			// BPFSg_ԍ
unsigned short pJudge[2][N_STAT] ;			// pX_()
unsigned char  jLower[2][N_STAT] ;			// 0:ȏ , 1:ȉ𔻒肷

// *****  @\[h 0 , ʏҋ@  *****
//    yA0F[h1 C yA1F[h3 ̑gݍ킹


// *****  @\[h 1:ً}nk  *****
#define 	FQ_MODE_1_P0		3		// [h 1 , yA0 ̃tC^ԍ
#define 	FQ_MODE_1_P1		3		// [h 1 , yA1 ̃tC^ԍ
//                     [BPFyA][Xe[^X]     0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10
const unsigned char  m1_t50ms[N_STAT]     =   {  0,  1,  3,  6,  7,  8, 10, 14, 17, 18, 18 }; 

const unsigned char  m1_f0num[2][N_STAT]  = { {  0,  0,  0,  0,  1,  1,  1,  1,  1,  0,  0 }, 
                                              {  6,  6,  6,  6,  6,  6,  7,  7,  7,  7,  6 } };

//           [KJS茵][BPFyA][Xe[^X]     0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10
const unsigned short m1_pJudge[3][2][N_STAT] = { { {  0, 13,  0,  3,  0, 13,  0,  3,  3,  3,  0 },    	// [h
                                                   {  0,  0,  3, 70,  0,  0,  3, 80,  0,  3,  0 } },  
                                                 { {  0, 13,  0,  0,  0, 13,  0,  0,  0,  0,  0 },    	// Gc[h
                                                   {  0,  0,  0, 70,  0,  0,  0, 80,  0,  0,  0 } },  
                                                 { {  0, 13,  0,  0,  0, 13,  0,  0,  3,  3,  0 },    	// ԃ[h
                                                   {  0,  0,  0, 70,  0,  0,  0, 80,  0,  6,  0 } } };

const unsigned char  m1_jLower[3][2][N_STAT] = { { {  0,  0,  0,  1,  0,  0,  0,  1,  1,  1,  0 },    	// [h
                                                   {  0,  0,  1,  0,  0,  0,  1,  0,  0,  1,  0 } },  
                                                 { {  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 },    	// Gc[h
                                                   {  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 } },  
                                                 { {  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  0 },    	// ԃ[h
                                                   {  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  0 } } };

// *****  @\[h 2:ʃx  *****
#define 	FQ_MODE_2_P0		3		// [h 2 , yA0 ̃tC^ԍ
#define 	FQ_MODE_2_P1		3		// [h 2 , yA1 ̃tC^ԍ
#define 	TH_PU_H 	CMPPRG_1_REF0_625		// _vb_High
#define 	TH_PU_L 	CMPPRG_3_REF0_437		// _vb_Low
#define 	TH_PON_H	CMPPRG_1_REF0_562		// _|[_High
#define 	TH_PON_L	CMPPRG_3_REF0_500		// _|[_Low
//                     [BPFyA][Xe[^X]     0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10
const unsigned char  m2_t50ms[N_STAT]     =   {  0,  4, 18, 24, 38, 44, 54, 70,120,140,140 }; 

const unsigned char  m2_f0num[2][N_STAT]  = { { 10, 10, 10, 10, 10, 10, 10, 11, 11, 10, 10 }, 
                                              { 10, 10, 10, 10, 10, 10, 10, 11, 11, 10, 10 } };
const unsigned short m2_pJudge[2][N_STAT] = { {  0,  1,  1,  1,  1,  1,  1,  0, 30,  0,  0 }, 
                                              {  0, 15,  1, 15,  1, 15,  1, 50,900,  0,  0 } };
const unsigned char  m2_jLower[2][N_STAT] = { {  0,  1,  1,  1,  1,  1,  1,  0,  1,  0,  0 }, 
                                              {  0,  0,  1,  0,  1,  0,  1,  0,  0,  0,  0 } };

// *****  @\[h 3 , 񌟒m  *****
#define 	FQ_MODE_3_P0		3		// [h 3 , yA0 ̃tC^ԍ
#define 	FQ_MODE_3_P1		3		// [h 3 , yA1 ̃tC^ԍ
//                     [BPFyA][Xe[^X]     0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10
const unsigned char  m3_t50ms[N_STAT]     =   {  0,  4, 18, 24, 38, 44, 54, 80, 90,140,140 }; 
const unsigned char  m3_f0num[N_STAT]     =   { 10, 10, 10, 10, 10, 10, 10, 11, 11, 10, 10 };
const unsigned short m3_pJudge[N_STAT]    =   {  0, 34,  1, 34,  1, 34,  1,  0,  0,  0,  0 };
const unsigned char  m3_jLower[N_STAT]    =   {  0,  0,  1,  0,  1,  0,  1,  0,  0,  0,  0 };


//=========================================================================

//*******************************
// @\[hݒ
//*******************************
void setMode(unsigned char mode) {
	extern	unsigned char	funcMode;		// @\[h , 0:ʏ, 1:ً}nk, 2:ʒ, 3:
	extern	unsigned char	kJudgeMode;		// KJS茵[h , 0= , 1=Gc , 2=
	unsigned char	pair , stat;

	switch (mode) {
		case 0: 			// ʏ
		case 3: 			// 
			funcMode = mode;
			for (stat = 0; stat <= (N_STAT - 1); stat++) {	// Xe[^Xɂ
				f0num[0][stat]  = m1_f0num[0][stat];	// ً}nkp
				pJudge[0][stat] = m1_pJudge[kJudgeMode][0][stat];
				jLower[0][stat] = m1_jLower[kJudgeMode][0][stat];
				t50ms[stat]     = m3_t50ms[stat];		// p
				f0num[1][stat]  = m3_f0num[stat];
				pJudge[1][stat] = m3_pJudge[stat];
				jLower[1][stat] = m3_jLower[stat];
			} // end for j
			chgBPFpair( 0, FQ_MODE_1_P0, f0num[0][0]); // ubNƂ2̃tC^_؊, (yA,,f0ԍ)
			chgBPFpair( 1, FQ_MODE_3_P1, f0num[1][0]); // ubNƂ2̃tC^_؊, (yA,,f0ԍ)
			CMPPRG_1_SetRef( CMPPRG_1_REF0_188 ); 	// CMPPRG_1 臒l ݒ
			CMPPRG_3_SetRef( CMPPRG_3_REF0_250 ); 	// CMPPRG_3 臒l ݒ
			break;
		case 1: 			// ً}nk
			funcMode = mode;
			for (stat = 0; stat <= (N_STAT - 1); stat++) {	// Xe[^Xɂ
				t50ms[stat] = m1_t50ms[stat];	
				for (pair = 0; pair <= 1; pair++) {				// BPFyAɂ
					f0num[pair][stat]  = m1_f0num[pair][stat];
					pJudge[pair][stat] = m1_pJudge[kJudgeMode][pair][stat];
					jLower[pair][stat] = m1_jLower[kJudgeMode][pair][stat];
				} // end for pair
			} // end for j
			chgBPFpair( 0, FQ_MODE_1_P0, f0num[0][0]); // ubNƂ2̃tC^_؊, (yA,,f0ԍ)
			chgBPFpair( 1, FQ_MODE_1_P1, f0num[1][0]); // ubNƂ2̃tC^_؊, (yA,,f0ԍ)
			CMPPRG_1_SetRef( CMPPRG_1_REF0_188 ); 	// CMPPRG_1 臒l ݒ
			CMPPRG_3_SetRef( CMPPRG_3_REF0_125 ); 	// CMPPRG_3 臒l ݒ
			break;
		case 2: 			// ʃx
			funcMode = mode;
			for (stat = 0; stat <= (N_STAT - 1); stat++) {	// Xe[^Xɂ
				t50ms[stat] = m2_t50ms[stat];	
				for (pair = 0; pair <= 1; pair++) {				// BPFyAɂ
					f0num[pair][stat]  = m2_f0num[pair][stat];
					pJudge[pair][stat] = m2_pJudge[pair][stat];
					jLower[pair][stat] = m2_jLower[pair][stat];
				} // end for pair
			} // end for j
			chgBPFpair( 0, FQ_MODE_2_P0, f0num[0][0]); // ubNƂ2̃tC^_؊, (yA,,f0ԍ)
			chgBPFpair( 1, FQ_MODE_2_P1, f0num[1][0]); // ubNƂ2̃tC^_؊, (yA,,f0ԍ)
			CMPPRG_1_SetRef( TH_PU_H ); 	// CMPPRG_1 臒l ݒ
			CMPPRG_3_SetRef( TH_PU_L ); 	// CMPPRG_3 臒l ݒ
			break;
		default: 
			break;
	} // end switch
}

//********************
// mXe[^X\
//********************
void disp_detStat(void) {
	extern	unsigned short	sig1PulseCount;			// M1 pXJEg
	extern	unsigned short	sig3PulseCount;			// M3 pXJEg
	extern	unsigned char	sigStat;			// M mXe[^X
	extern	unsigned char	preStat;			// O̐MmXe[^X
	extern	unsigned char	detStatVisible;		// mXe[^X\tO, 0=\, 1=v_\, 2=S\
	extern	unsigned short	*ptr_bpf_f0;		// bpf_f0[16] ւ̃|C^

	if ( (detStatVisible >= 1) && (sigStat != preStat) ) {
		set_prtdev_sio(); 				// \uSIO(UART)ɂ
		printf(",(%d", sigStat);								// (M1mXe[^X, 
		printf(",%d", *(ptr_bpf_f0 + f0num[0][sigStat] ) );	// g, 
		printf(",%d", sig1PulseCount);							// JEgl), 
		printf(",%d", *(ptr_bpf_f0 + f0num[1][sigStat] ) );	// g, 
		printf(",%d)", sig3PulseCount);							// JEgl), 
		preStat = sigStat;					// O̐MmXe[^X
	} // end if
}

//*******************************
// DigBuf_1 荞݃[`
//	ŏ̐MpXm
//	M`C_pXmƁC荞݂|Dsig1PulseCount++D
//*******************************
#pragma interrupt_handler DigBuf_1_ISR
void DigBuf_1_ISR(void) {
	extern	unsigned char	fixedMode;		// Œ胂[h , 0:ʏ, 1:ً}nk, 2:ʒ, 3:
	extern	unsigned char	funcMode;		// @\[h , 0:ʏ, 1:ً}nk, 2:ʒ, 3:
	extern	unsigned short	sig1PulseCount;			// M1 pXJEg
	extern	unsigned short	sig3PulseCount;			// M3 pXJEg
	extern	unsigned char	ct8_detForm_intCount;	// ct8_detForm荞݉񐔃JEg
	extern	unsigned char	sigStat;				// M mXe[^X
	extern	unsigned char	preStat;				// O̐MmXe[^X

	switch (funcMode) {
		case 3: 			// 񌟒m
			if (fixedMode == 3) {	// Œ胂[h񌟒m Ȃ
				break;				// Ȃ
			} else {				// Œ胂[hʏ탂[hȂ
				clr_detStat();		// mXe[^X NACACh
			} // end if fixedMode
			// Ĉȉ
		case 0: 			// ʏҋ@
			setMode(1);					// ً}nk񃂁[hɈڍs
			// Ĉȉ
		case 1: 			// ً}nk
			if (sigStat == 0 && ct8_detForm_intCount == 0) {
				sigStat = 1;						// M mXe[^X = 1
				chgBPFpair( 0, FQ_MODE_1_P0, f0num[0][sigStat]); 	// ubNƂ2̃tC^_؊
				chgBPFpair( 1, FQ_MODE_1_P1, f0num[1][sigStat]); 	// ubNƂ2̃tC^_؊
				Counter8_detForm_Stop();						// Counter8_detForm ~
				Counter8_detForm_WritePeriod(CT8dF_DIV - 1);	// JEglZbg
				sig1PulseCount = 0;								// M1 pXJEg NA
				sig3PulseCount = 0;								// M3 pXJEg NA
				Counter8_detForm_Start();						// Counter8_detForm X^[g
				Counter8_detForm_EnableInt();					// Counter8_detForm 荞݋
			} // end if sigStat
			sig1PulseCount++;					// M1 pXJEg Inc
			break;
		case 2: 			// ʃx
			sig1PulseCount++;					// M1 pXJEg Inc
			break;
		default: 
			break;
	} // end switch
}

//*******************************
// DigBuf_3 荞݃[`
//*******************************
#pragma interrupt_handler DigBuf_3_ISR
void DigBuf_3_ISR(void) {
	extern	unsigned char	funcMode;				// @\[h , 0:ʏ, 1:ً}nk, 2:ʒ, 3:
	extern	unsigned short	sig1PulseCount;			// M1 pXJEg
	extern	unsigned short	sig3PulseCount;			// M3 pXJEg
	extern	unsigned char	sigStat;				// M mXe[^X
	extern	unsigned char	jDetFlg;				// 񌟏otO, 0=o, 1=o
	extern	unsigned short	JADelay;				// Z x(b)

	switch (funcMode) {
		case 0: 			// ʏҋ@
			setMode(3);					// 񌟒m[hɈڍs
			// Ĉȉ
		case 3: 			// 񌟒m
			if (sigStat == 0 && ct8_detForm_intCount == 0) {
				sigStat = 1;					//	 1 : 440Hz ŏ1m 0.1secJEg
				chgBPFpair( 1, FQ_MODE_3_P1, f0num[1][sigStat]); 	// ubNƂ2̃tC^_؊
				Counter8_detForm_Stop();					// Counter8_detForm ~
				Counter8_detForm_WritePeriod(CT8dF_DIV - 1);	// JEglZbg
				sig3PulseCount = 0;							// M3 pXJEg NA
				Counter8_detForm_Start();					// Counter8_detForm X^[g
				Counter8_detForm_EnableInt();				// Counter8_detForm ݋
			} // end if sigStat
			if (sigStat == (M3_END_STAT - 1)) {
				sigStat = M3_END_STAT;			//  8 :  팟m1
				Counter16_JAdj1_Stop();			// Counter16_JAdj1 ~Cォ󂯕tD悳
				Counter8_JAdj0_Stop();			// Counter8_JAdj0 ~
				Counter16_JAdj1_WritePeriod(JADelay - 1);	// JEglZbg
				Counter8_JAdj0_WritePeriod(99);				// JEglZbg
				Counter8_JAdj0_Start();			// Counter8_JAdj0 X^[g
				Counter16_JAdj1_Start();		// Counter16_JAdj1 X^[g
				Counter16_JAdj1_EnableInt();	// Counter16_JAdj1 ݋
				jDetFlg = 1;					// 񌟒mtO, 0=m, 1=m
				sig3PulseCount = 0;				// M3 pXJEg NA
				DigBuf_1_EnableInt();		// DigBuf_1 ݋
			} // end if sigStat
			sig3PulseCount++;					// M3 pXJEg3 Inc
			break;
		case 1: 			// ً}nk
			sig3PulseCount++;					// M3 pXJEg Inc
			break;
		case 2: 			// ʃx
			if (sigStat == 0 && ct8_detForm_intCount == 0) {
				sigStat = 1;						//	Xe[^X 1 :  
				chgBPFpair( 0, FQ_MODE_2_P0, f0num[0][sigStat]); 	// ubNƂ2̃tC^_؊
				chgBPFpair( 1, FQ_MODE_2_P1, f0num[1][sigStat]); 	// ubNƂ2̃tC^_؊
				Counter8_detForm_Stop();						// Counter8_detForm ~
				Counter8_detForm_WritePeriod(CT8dF_DIV - 1);	// JEglZbg
				sig1PulseCount = 0;								// M1 pXJEg NA
				sig3PulseCount = 0;								// M3 pXJEg NA
				Counter8_detForm_Start();						// Counter8_detForm X^[g
				Counter8_detForm_EnableInt();					// Counter8_detForm 荞݋
			} // end if sigStat
			sig3PulseCount++;					// M3 pXJEg Inc
			break;
		default: 
			break;
	} // end switch
}

//********************
// DigBuf_1, 3 荞ݏ Enable
//   2930b̋ߖTŐMM֎~ , Z𐳊mɂ
//   荞݂̗\񂪗LĂȂBɂ ENSWINTNA𔺂C
//   v̊NbNꎞIɋ֎~AׁB
//********************
void cntl_dBuf13IntEnable(void) {
	extern	unsigned char	jDetFlg;		// 񌟏otO, 0=o, 1=o
	extern	unsigned char	second;			// 0-59 seconds
	extern	unsigned char	minute;			// 0-59 minutes
	unsigned short ct16count;

	ct16count = Counter16_JAdj1_wReadCounter();
	// 2930b̋ߖTŐMM֎~
	if ((jDetFlg == 1) && (ct16count == 1)) {	// 񌟏o && Z1bO
		DigBuf_1_DisableInt();	// DigBuf_1 ݋֎~
		DigBuf_3_DisableInt();	// DigBuf_3 ݋֎~
		clr_detStat();			// mXe[^X NACACh
	} // end if

	// 2931bŐMM
	if ((jDetFlg == 0) && (minute == J_ADJ_MIN) && (second == (J_ADJ_SEC + 1))) {
		DigBuf_1_EnableInt();	// DigBuf_1 ݋
		DigBuf_3_EnableInt();	// DigBuf_3 ݋
		clr_detStat();			// mXe[^X NACACh
	} // end if
}

//*******************************
//	Counter8_detForm_ISR 荞݃[`i0.05bj
//	MtH[}bgmF
//	ŏ1ڂ̐MpXmɓ삷
//*******************************
#pragma interrupt_handler Counter8_detForm_ISR
void Counter8_detForm_ISR(void) {
	extern	unsigned char	funcMode;				// @\[h , 0:ʏ, 1:ً}nk, 2:ʒ, 3:
	extern	unsigned short	sig1PulseCount;			// M1 pXJEg
	extern	unsigned short	sig3PulseCount;			// M3 pXJEg
	extern	unsigned char	ct8_detForm_intCount;	// ct8_detForm荞݉񐔃JEg
	extern	unsigned char	sigStat;				// M mXe[^X
	extern	unsigned char	jDetFlg;				// M mtO, 0=m, 1=1񌟒m, 2=2񌟒m, ...

	M8C_EnableGInt;					// d荞݋
	switch (funcMode) {
		case 1: 			// ً}nk
			ct8_detForm_intCount++;								// `JEg+1
			if ( ct8_detForm_intCount == t50ms[sigStat] ) { 	// Ԃ̏IȂ
				disp_detStat();			// mXe[^X\(SIO)
				if ( ((jLower[0][sigStat] == 0) && (sig1PulseCount >= pJudge[0][sigStat])) || 	// yA0̃pX
					 ((jLower[0][sigStat] == 1) && (sig1PulseCount <= pJudge[0][sigStat])) ) {	// ĂȂ
					if ( ((jLower[1][sigStat] == 0) && (sig3PulseCount >= pJudge[1][sigStat])) || 	// yA1̃pX
						 ((jLower[1][sigStat] == 1) && (sig3PulseCount <= pJudge[1][sigStat])) ) {	// ĂȂ
						sigStat++;						// M1mXe[^X+1
						chgBPFpair( 0, FQ_MODE_1_P0, f0num[0][sigStat]); // ubNƂ2̃tC^_؊, (yA,,f0ԍ)
						chgBPFpair( 1, FQ_MODE_1_P1, f0num[1][sigStat]); // ubNƂ2̃tC^_؊, (yA,,f0ԍ)
						sig1PulseCount = 0;				// M1 pXJEg NA
						sig3PulseCount = 0;				// M3 pXJEg NA
						if (sigStat >= M1_END_STAT) {	// m
							kDetFlg++;					// KJS mtO +1
							kAlarm_pol();				// xo |[O , kEnablekDetFlgŐ
							audioOut_pol();				// WIo̓|[O, audioEnablekDetFlgŐ
							clr_detStat();				// mXe[^X NACACh
						} // end if sigStat
					} else {
						clr_detStat();			// mXe[^X NACACh
					} // end if sig3PulseCount
				} else {
					clr_detStat();			// mXe[^X NACACh
				} // end if sig1PulseCount
			} // end if ct8_detForm_intCount
			break;
		case 2: 			// ʃx
			ct8_detForm_intCount++;								// `JEg+1
			if ( ct8_detForm_intCount == t50ms[sigStat] ) { 	// Ԃ̏IȂ
				disp_detStat();			// mXe[^X\(SIO)
				if ( ((jLower[0][sigStat] == 0) && (sig1PulseCount >= pJudge[0][sigStat])) || 	// yA0̃pX
					 ((jLower[0][sigStat] == 1) && (sig1PulseCount <= pJudge[0][sigStat])) ) {	// ĂȂ
					if ( ((jLower[1][sigStat] == 0) && (sig3PulseCount >= pJudge[1][sigStat])) || 	// yA1̃pX
						 ((jLower[1][sigStat] == 1) && (sig3PulseCount <= pJudge[1][sigStat])) ) {	// ĂȂ
						sigStat++;						// mXe[^X+1
						if (sigStat == (M2_END_STAT - 2)) {			// sigStat == 7
							chgBPFpair( 0, FQ_MODE_2_P0, f0num[0][sigStat]); // ubNƂ2̃tC^_؊, (yA,,f0ԍ)
							chgBPFpair( 1, FQ_MODE_2_P1, f0num[1][sigStat]); // ubNƂ2̃tC^_؊, (yA,,f0ԍ)
							CMPPRG_1_SetRef( TH_PON_H ); 	// CMPPRG_1 臒l ݒ
							CMPPRG_3_SetRef( TH_PON_L ); 	// CMPPRG_3 臒l ݒ
						} // end if
						sig1PulseCount = 0;				// M1 pXJEg NA
						sig3PulseCount = 0;				// M3 pXJEg NA
						if (sigStat >= M2_END_STAT) {	// m		// sigStat >= 9
							UART_1_CPutString(" , Signal Level OK.");
							UART_1_PutCRLF();					// s(CR,LF)
							clr_detStat();				// mXe[^X NACACh
							CMPPRG_1_SetRef( TH_PU_H ); 	// CMPPRG_1 臒l ݒ
							CMPPRG_3_SetRef( TH_PU_L ); 	// CMPPRG_3 臒l ݒ
						} // end if sigStat
					} else {
						if ( jLower[1][sigStat] == 0) {
							UART_1_CPutString(" , Under");
							UART_1_PutCRLF();					// s(CR,LF)
							clr_detStat();				// mXe[^X NACACh
							CMPPRG_1_SetRef( TH_PU_H ); 	// CMPPRG_1 臒l ݒ
							CMPPRG_3_SetRef( TH_PU_L ); 	// CMPPRG_3 臒l ݒ
						} // end if Lower
					} // end if sig3PulseCount
				} else {
					if ( jLower[0][sigStat] == 1) {
						UART_1_CPutString(" , Over");
						UART_1_PutCRLF();					// s(CR,LF)
						clr_detStat();				// mXe[^X NACACh
						CMPPRG_1_SetRef( TH_PU_H ); 	// CMPPRG_1 臒l ݒ
						CMPPRG_3_SetRef( TH_PU_L ); 	// CMPPRG_3 臒l ݒ
					} // end if Lower
				} // end if sig1PulseCount
			} else if ( ct8_detForm_intCount >= t50ms[(N_STAT - 1)] ) { 	// 7bȏ
				clr_detStat();				// mXe[^X NACACh
				CMPPRG_1_SetRef( TH_PU_H ); 	// CMPPRG_1 臒l ݒ
				CMPPRG_3_SetRef( TH_PU_L ); 	// CMPPRG_3 臒l ݒ
			} // end if ct8_detForm_intCount
			break;
		case 3: 			// 
			ct8_detForm_intCount++;								// `JEg+1
			if ( (sigStat < M3_END_STAT) && (ct8_detForm_intCount == t50ms[sigStat]) ) { 	// Ԃ̏IȂ
				disp_detStat();			// mXe[^X\(SIO)
				if ( ((jLower[1][sigStat] == 0) && (sig3PulseCount >= pJudge[1][sigStat])) || 	// yA1̃pX
					 ((jLower[1][sigStat] == 1) && (sig3PulseCount <= pJudge[1][sigStat])) ) {	// ĂȂ
					sigStat++;						// mXe[^X+1
					if (sigStat == (M3_END_STAT - 1)) {		// sigStat == 7
						chgBPFpair( 1, FQ_MODE_3_P1, f0num[1][sigStat]); // ubNƂ2̃tC^_؊, (yA,,f0ԍ)
					} // end if
					if (sigStat == (M3_END_STAT - 2)) {		// sigStat == 6
						DigBuf_1_DisableInt();			// DigBuf_1 ݋֎~
					} // end if
					sig3PulseCount = 0;				// M3 pXJEg NA
				} else {
					clr_detStat();				// mXe[^X NACACh
				} // end if sig3PulseCount
			} else if ( ct8_detForm_intCount >= t50ms[(N_STAT - 1)] ) { 	// 7bȏ
				DigBuf_1_EnableInt();		// DigBuf_1 ݋
				clr_detStat();				// mXe[^X NACACh
			} // end if ct8_detForm_intCount
			break;
		case 0: 			// ʏҋ@
			// ɂ͗Ȃ͂
			break;
		default: 
			break;
	} // end switch
}

//*******************************
//	mXe[^X NACACh
//*******************************
void clr_detStat(void) {
	extern	unsigned char	fixedMode;		// Œ胂[h , 0:ʏ, 1:ً}nk, 2:ʒ, 3:
	extern	unsigned short	sig1PulseCount;			// M1 pXJEg
	extern	unsigned short	sig3PulseCount;			// M3 pXJEg
	extern	unsigned char	ct8_detForm_intCount;	// ct8_detForm荞݉񐔃JEg
	extern	unsigned char	sigStat;				// M mXe[^X
	extern	unsigned char	preStat;				// O̐MmXe[^X
	extern	unsigned char	jAdjEnable;				// ZCl[u, 0=Z֎~, 1=Z

	Counter8_detForm_Stop();		// Counter8_detForm ~
	Counter8_detForm_DisableInt();	// Counter8_detForm 荞݋֎~
	Counter8_detForm_WritePeriod(CT8dF_DIV - 1);	// JEglZbg
	setMode(fixedMode);				// @\[hݒ , 0:ʏ, 1:ً}nk, 2:ʒ, 3:
	sigStat = 0;					// M mXe[^X ,  0 : ACh
	preStat = 0;					// O̐MmXe[^X
	ct8_detForm_intCount = 0;		// ct8_detForm荞݉񐔃JEg NA
	sig1PulseCount = 0;				// M1 pXJEg NA
	sig3PulseCount = 0;				// M3 pXJEg NA
}

//*******************************
//	Mm 
//*******************************
void init_Det(void) {
	extern	unsigned char	fixedMode;		// Œ胂[h , 0:ʏ, 1:ً}nk, 2:ʒ, 3:
	extern	unsigned char	kJudgeMode;		// KJS茵[h , 0= , 1=Gc , 2=

	DigBuf_1_Start();		// DigBuf_1 X^[g
	DigBuf_3_Start();		// DigBuf_3 X^[g
	fixedMode = 0;
	clr_detStat();			// mXe[^X NACACh
	kJudgeMode = 2;			// KJS茵[h , 0= , 1=Gc , 2=
	DigBuf_1_EnableInt();	// DigBuf_1 ݋
	DigBuf_3_EnableInt();	// DigBuf_3 ݋

}

//********************
// HELP mR}h('D')
//********************
void help_Det(void) {
	UART_1_CPutString(" DVx ; Visible, x=0:Normal, 1:Detail");
	UART_1_PutCRLF();					// s(CR,LF)
	UART_1_CPutString(" DMx ; Func Mode , x=0:Normal, 1:KJS, 2:Vol-Adj, 3:Jihou");
	UART_1_PutCRLF();					// s(CR,LF)
	UART_1_CPutString(" DJx ; KJS Judge Mode , x=0:Proper, 1:Rough, 2:Medium");
	UART_1_PutCRLF();					// s(CR,LF)
}

//*******************************
// MmR}h('D') 
//*******************************
void cmdBR_Det(unsigned char *str) {
	extern	unsigned char	fixedMode;		// Œ胂[h , 0:ʏ, 1:ً}nk, 2:ʒ, 3:
	extern	unsigned char	detStatVisible;	// mXe[^X\tO, 0=\, 1=\
	extern	unsigned char	kJudgeMode;		// KJS茵[h , 0= , 1=Gc , 2=
	unsigned char *strPtr;
	unsigned char num;

	set_prtdev_sio(); 				// \uSIO(UART)ɂ
	strPtr = str;
	strPtr++;
	switch (*strPtr) {
		case 'V' : 		// Xe[^XVisible
		case 'v' : 
			strPtr++;
			if ( (num = hexChar2num(*strPtr, 2)) <= 2 ) {
				detStatVisible = num;		// mXe[^X\tO, 0=\, 1=v_\, 2=S\
			} else {
				detStatVisible = 0;			// mXe[^X\tO, 0=\
			} // end if
			disp_DetMode();			// o[h\
			break;
		case 'M' : 		// @\[hݒ
		case 'm' : 
			strPtr++;
			if ( (num = hexChar2num(*strPtr, 3)) <= 3 ) {
				fixedMode = num;	// Œ胂[h , 0:ʏ, 1:ً}nk, 2:ʒ, 3:
			} else {
				fixedMode = 0;		// Œ胂[h , 0:ʏ, 1:ً}nk, 2:ʒ, 3:
			} // end if
			clr_detStat();			// mXe[^X NACACh
			disp_DetMode();			// o[h\
			break;
		case 'J' : 		// KJS茵[hݒ
		case 'j' : 
			strPtr++;
			if ( (num = hexChar2num(*strPtr, 2)) <= 2 ) {
				kJudgeMode = num;	// KJS茵[h , 0= , 1=Gc , 2=
			} else {
				kJudgeMode = 0;		// KJS茵[h , 0= , 1=Gc , 2=
			} // end if
			disp_DetMode();			// o[h\
			break;
		case 'H' : 		// Help
		case 'h' : 
			help_Det();				// HELP DetR}h
			break;
		default : 
			msg_InvalCmd();			// \_R}h
			help_Det();				// HELP DetR}h
			break;
	} // end switch cmd[1]
}

//*******************************
// o[h\
//*******************************
void disp_DetMode(void) {
	extern	unsigned char	detStatVisible;	// mXe[^X\tO, 0=\, 1=\
	extern	unsigned char	fixedMode;		// Œ胂[h , 0:ʏ, 1:ً}nk, 2:ʒ, 3:
	extern	unsigned char	kJudgeMode;		// KJS茵[h , 0= , 1=Gc , 2=

	printf("Visible = %d: ", detStatVisible);
	switch (detStatVisible) {		// mXe[^X\tO
		case 0: 						// 0:ʏ
			msg_Normal();				// \_Normal
			break;
		case 1: 						// 1:ڍ
			UART_1_CPutString("Detail");
			break;
		default : 
			break;
	} // end switch
	UART_1_PutCRLF();					// s(CR,LF)

	printf("Function= %d: ", fixedMode);
	switch (fixedMode) {			// Œ胂[h
		case 0: 						// 0:ʏ
			msg_Normal();				// \_Normal
			break;
		case 1: 						// 1:ً}nk(KJS)
			UART_1_CPutString("KJS");
			break;
		case 2: 						// 2:ʒ
			UART_1_CPutString("Vol-Adj");
			break;
		case 3: 						// 3:
			UART_1_CPutString("Jihou");
			break;
		default : 
			break;
	} // end switch
	UART_1_PutCRLF();					// s(CR,LF)

	UART_1_CPutString("KJS-Judge = ");
	switch ( kJudgeMode ) {			// KJS茵[h
		case 0: 						// 0=
			UART_1_CPutString("Proper");
			break;
		case 1: 						// 1=Gc
			UART_1_CPutString("Rough");
			break;
		case 2:							 // 2=
			UART_1_CPutString("Medium");
			break;
		default : 
			break;
	} // end switch kJudgeMode
	UART_1_PutCRLF();				// s(CR,LF)
}

