//************************************************************
//		񃋁[`
//			Copyright by S.Asakura
//************************************************************
#include 	<m8c.h>			// part specific constants and macros
#include 	"PSoCAPI.h" 	// PSoC API definitions for all User Modules
#include	"message.h"		// bZ[W\

//*********************
//	݌v
//*********************
//************************************************************
//	mFXe[^X sigStat
//	 0 : ACh
//	 1 : 440Hz ŏ1m 0.2secJEg
//	 2 : 440Hz, 1ڊmFρ`2ڌm҂
//	 3 : 440Hz, 2ڌm  0.3secJEg
//	 4 : 440Hz, 2ڊmFρ`3ڌm҂
//	 5 : 440Hz, 3ڌm  0.3secJEg
//	 6 : 440Hz, 3ڊmFρ`440HzmFend
//	 7 : 880Hz ŏ1mm҂
//	 8 :  팟o1
//	 9 :  팟o2
//************************************************************


//*******************************
//		O֐
//*******************************
#include	"uart.h"		// UART VAʐM
#include	"printf.h"		// printf to
#include	"rtc-inner.h"	// RTCA^C NbN
#include	"detect.h"		// Mm[`

//*******************************
//	萔 `
//	vg^Cv錾
//	O[oϐ
//*******************************
#define 	FIRST_FLG		// ŏɕϐ̒`C2ڈȍ~͊Oϐ錾邽߂̃tO
#include	"jihou.h"		// 񃋁[`

//*******************************
//	O[oϐ
//*******************************

//=========================================================================


//*******************************
// Counter16_JAdj1_ISR [`iJ_ADJ_MIN  J_ADJ_SECb j
// Zs
// oɁCۂɍZ|܂ł̎Ԃṽׂ^C}I̊
//*******************************
#pragma interrupt_handler Counter16_JAdj1_ISR
void Counter16_JAdj1_ISR(void) {
	extern	unsigned char	second;			// 0-59 seconds
	extern	unsigned char	minute;			// 0-59 minutes
	extern	unsigned char	jAdjStatLCD;	// ZXe[^X(LCDp), 0=ʏ, 1=Zς
	extern	unsigned char	jAdjStatSIO;	// ZXe[^X(SIOp), 0=ʏ, 1=Zς
	extern	unsigned char	jDetFlg;		// 񌟏otO, 0=o, 1=o
	extern	unsigned char	jAdjEnable;		// ZCl[u, 0=Z֎~, 1=Z

	if ( jAdjEnable ) {		// ZȂ
		rtc_inner_Stop();			// RTC  vXgbv
		second = J_ADJ_SEC;			// 30b
		minute = J_ADJ_MIN;			// 29
		rtc_inner_Start();			// RTC  vX^[g
		jAdjStatLCD  = 1;			// ZXe[^X(LCDp), 0=ʏ, 1=Zς
		jAdjStatSIO  = 1;			// ZXe[^X(SIOp), 0=ʏ, 1=Zς
	} // end if
	Counter16_JAdj1_DisableInt();	// Counter16_JAdj1 ݋֎~
	Counter16_JAdj1_Stop();			// Counter16_JAdj1 ~
	Counter8_JAdj0_Stop();			// Counter8_JAdj0 ~
	Counter16_JAdj1_WritePeriod(JADelay - 1);	// JEglZbg
	Counter8_JAdj0_WritePeriod(99);				// JEglZbg
	jDetFlg = 0;					// 񌟏otO, 0=o, 1=o
	DigBuf_1_EnableInt();			// DigBuf_1 ݋
	DigBuf_3_EnableInt();			// DigBuf_3 ݋
}

//********************
// Xe[^X\(SIO)
//********************
void dispJihouStat(void) {
	extern	unsigned short	sig3PulseCount; 	// M3 pXJEg
	extern	unsigned char	sigStat;			// M mXe[^X
	extern	unsigned char	jAdjStatSIO;		// ZXe[^X(SIOp), 0=ʏ, 1=Zς
	extern	unsigned char	funcMode;			// @\[h , 0:ʏ, 1:ً}nk, 2:ʒ, 3:

	if (funcMode == 3) {
		if (sigStat == M3_END_STAT) {		//  8 :  팟o1
			UART_1_CPutString(" , J_Det");
			sigStat = (M3_END_STAT + 1);		//  9 :  팟o2
			sig3PulseCount = 0;		// pX JEg   NA
		} // end if sigStat
	} // end if funcMode
	if (jAdjStatSIO == 1) {		// ZXe[^X(SIOp), 0=ʏ, 1=Zς
		UART_1_CPutString(" , J_Adj");
		jAdjStatSIO = 0;		// ZXe[^X(SIOp), 0=ʏ, 1=Zς
	} // end if jAdjStatSIO
}

//********************
// Xe[^X\(LCD)
//********************
void dispJStatLCD(void) {
	extern	unsigned char	jAdjStatLCD;	// ZXe[^X(LCDp), 0=ʏ, 1=Zς
	extern	unsigned char	second;			// 0-59 seconds
	extern	unsigned char	minute;			// 0-59 minutes

	if ((minute == J_ADJ_MIN) && (second == (J_ADJ_SEC - 2))) {
		jAdjStatLCD = 0;		// ZXe[^X(LCDp), 0=ʏ, 1=Zς
	} // end if minute,second
	set_prtdev_lcd();			// \uLCDɂ
	if (jAdjStatLCD == 1) {		// ZXe[^X(LCDp), 0=ʏ, 1=Zς
		print_chr('J');			// 1 Print
	} else {
		print_chr(' ');
	} // end if jAdjStatLCD
}

//*******************************
//	 
//*******************************
void init_Jihou(void) {
	extern	unsigned char	jAdjStatSIO;	// ZXe[^X(SIOp), 0=ʏ, 1=Zς
	extern	unsigned char	jAdjStatLCD;	// ZXe[^X(LCDp), 0=ʏ, 1=Zς
	extern	unsigned char	jDetFlg;		// 񌟏otO, 0=o, 1=o
	extern	unsigned short	JADelay;		// Z x(b)
	extern	unsigned char	jAdjEnable;		// ZCl[u, 0=Z֎~, 1=Z

	jAdjStatLCD = 0;				// ZXe[^X(LCDp), 0=ʏ, 1=Zς
	jAdjStatSIO = 0;				// ZXe[^X(SIOp), 0=ʏ, 1=Zς
	jDetFlg = 0;					// 񌟏otO, 0=o, 1=o
	JADelay = (J_ADJ_MIN * 60 + J_ADJ_SEC) ;		// Z x(b)
	Counter16_JAdj1_WritePeriod(JADelay - 1);	// ^CAbvlݒ
	jAdjEnable = 0;					// ZCl[u, 0=Z֎~, 1=Z
}

